--local vars
local LastUpdate = 0
local UpdateInterval = 1
local VarsLoaded = false
local Help = "Usage /KSSA | /SSAnchor [left | right | top | bottom | off]."

--Global vars
KSSAnchor_Method = "off"
KSSAnchor_ShammyShields_ESIcon = false


local function print(msg)
	DEFAULT_CHAT_FRAME:AddMessage("KSSAnchor: " .. tostring(msg))
end

function KSSAnchor_OnLoad(self)
	SlashCmdList["KSSAnchor"]=KSSAnchor_Command
	SLASH_KSSAnchor1,SLASH_KSSAnchor2 = "/KSSA","/SSAnchor"
    KSSAnchorFrame:RegisterEvent("ADDON_LOADED")
	KSSAnchorFrame:RegisterEvent("PLAYER_LOGIN")
	print("Loaded."..Help)
end

function DependentsLoaded(Verbose)
	local Ret = true
	--check for required addons
	if HealBot_Action == nil and ShammyShields == nil then
		if Verbose then print("Both HealBot and ShammyShields are not loaded."); end
		Ret = false
	elseif HealBot_Action and ShammyShields == nil then
		if Verbose then print("ShammyShields is not loaded."); end
		Ret = false
	elseif HealBot_Action == nil and ShammyShields then
		if Verbose then print("HealBot is not loaded."); end
		Ret = false
	end
	return Ret
end

function KSSAnchor_Command(Msg,Editbox)
	Msg=strlower(Msg)
 	if Msg == "" or Msg ~= "left" and Msg ~= "right" and Msg ~= "top" and Msg ~= "bottom" and Msg ~= "off"  and Msg ~= "disable" then
		print(Help)
	else
		if DependentsLoaded(false) then
			if Msg=="left" then
				KSSAnchor_Method=Msg
				ShammyShields:ClearAllPoints()
				ShammyShields:SetPoint("Right","HealBot_Action","Left",0,0)
			elseif Msg=="right" then
				KSSAnchor_Method=Msg
				ShammyShields:ClearAllPoints()
				ShammyShields:SetPoint("Left","HealBot_Action","Right",0,0)
			elseif Msg=="top" then
				KSSAnchor_Method=Msg
				local Offset = ShammyShields_BG:GetHeight() - 85
				ShammyShields:ClearAllPoints()
				ShammyShields:SetPoint("Bottom","HealBot_Action","Top",0,Offset)
			elseif Msg=="bottom" then
				KSSAnchor_Method=Msg
				ShammyShields:ClearAllPoints()
				ShammyShields:SetPoint("Top","HealBot_Action","Bottom",0,0)
			elseif Msg=="off" then
				KSSAnchor_Method=Msg
				ShammyShields:ClearAllPoints()
			elseif Msg=="disable" then
				ShammyShields:ClearAllPoints()
			end
		end
	end
	print("Current anchoring method is: "..KSSAnchor_Method)
end

function KSSAnchor_OnUpdate(self,elapsed)
	
	if VarsLoaded == true then
		LastUpdate = LastUpdate + elapsed

		--look for frame size changes due to earth shield and re-Anchor if needed
		if (LastUpdate > UpdateInterval) then
			if DependentsLoaded(false) then --check for the frames
				local _, relativeTo, _, _, _ = ShammyShields:GetPoint(1) --get the current anchor frame
				if KSSAnchor_Method ~= "off" and HealBot_Action:IsVisible() then
					--healbot is visable and we should be anchorod to it so check everything
					if relativeTo ~= HealBot_Action then --is it anchored to HealBot?
						--HealBot_Action is not currently ShammyShields Parent to anchor it,
						--i.e. not Anchored but should be so lets reanchor it.
						if KSSAnchor_Method ~= "off" then --but not if its set to off
							print("Anchoring Shammy Shields to HealBot.")
							KSSAnchor_Command(KSSAnchor_Method,nil)
						end
					elseif KSSAnchor_ShammyShields_ESIcon ~= ShammyShields_ESIcon:IsVisible() then --has EarthShield status changed?
						KSSAnchor_ShammyShields_ESIcon = ShammyShields_ESIcon:IsVisible() --save new status
						if KSSAnchor_Method == "top" then --update position
							print("Detected EarthShield ability changed.")
							KSSAnchor_Command("top",nil)
						end
					end
				elseif KSSAnchor_Method ~= "off" and HealBot_Config.DisabledNow == 1 then
					--we are suppose to be anchored to healbot but it is disabled
					if relativeTo == HealBot_Action then --is it anchored to HealBot?
						--we are anchored to healbot but healbot is disabled so stop anchoring until it is healbot is enabled
						print("Anchoring to HealBot disbled while HealBot is disabled.")
						KSSAnchor_Command("disable",nil)
					end
				end
			end
			LastUpdate = 0
		end
	end
	
end

function KSSAnchor_OnEvent(self,event,...)
	if event == "ADDON_LOADED" and select(1,...) == "KSSAnchor" then
		VarsLoaded = true
	elseif event == "PLAYER_LOGIN" then
		DependentsLoaded(true)
	end
end